// This file is generated by kconfig_compiler_kf5 from kalarmconfig.kcfg.
// All changes you do to this file will be lost.
#ifndef PREFERENCESBASE_H
#define PREFERENCESBASE_H

#include <kalarm_debug.h>

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

#include "timeperiod.h"
#include "kalocale.h"
#include <QFontDatabase>
#include <KColorScheme>
#include <QFont>
#include <QColor>
#include <qnamespace.h>

class PreferencesBase : public KConfigSkeleton
{
  Q_OBJECT
  public:
    enum Backend { Kresources, Akonadi };
    enum MailClient { sendmail, kmail };
    enum SoundType { Sound_None, Sound_Beep, Sound_File, Sound_Speak };
    enum CmdLogType { Log_Discard, Log_File, Log_Terminal };
    enum RecurType { Recur_None, Recur_Login, Recur_SubDaily, Recur_Daily, Recur_Weekly, Recur_Monthly, Recur_Yearly };
    enum Feb29Type { Feb29_Feb28, Feb29_Mar1, Feb29_None };

    static PreferencesBase *self();
    ~PreferencesBase();

    /**
      Set KAlarm version
    */
    static
    void setVersion( const QString & v )
    {
      if (!self()->isImmutable( QStringLiteral( "Version" ) ))
        self()->mVersion = v;
    }

    /**
      Get KAlarm version
    */
    static
    QString version()
    {
      return self()->mVersion;
    }

    /**
      Set Data storage backend
    */
    static
    void setBackend( Backend v )
    {
      if (!self()->isImmutable( QStringLiteral( "Backend" ) ))
        self()->mBackend = v;
    }

    /**
      Get Data storage backend
    */
    static
    Backend backend()
    {
      return static_cast<Backend>(self()->mBackend);
    }

    /**
      Set Time zone
    */
    static
    void setBase_TimeZone( const QString & v )
    {
      if (v != self()->mBase_TimeZone && !self()->isImmutable( QStringLiteral( "Base_TimeZone" ) )) {
        self()->mBase_TimeZone = v;
        self()->mSettingsChanged |= signalBase_TimeZoneChanged;
      }
    }

    /**
      Get Time zone
    */
    static
    QString base_TimeZone()
    {
      return self()->mBase_TimeZone;
    }

    /**
      Set Holiday region
    */
    static
    void setBase_HolidayRegion( const QString & v )
    {
      if (v != self()->mBase_HolidayRegion && !self()->isImmutable( QStringLiteral( "Base_HolidayRegion" ) )) {
        self()->mBase_HolidayRegion = v;
        self()->mSettingsChanged |= signalBase_HolidayRegionChanged;
      }
    }

    /**
      Get Holiday region
    */
    static
    QString base_HolidayRegion()
    {
      return self()->mBase_HolidayRegion;
    }

    /**
      Set Foreground color
    */
    static
    void setDefaultFgColour( const QColor & v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultFgColour" ) ))
        self()->mDefaultFgColour = v;
    }

    /**
      Get Foreground color
    */
    static
    QColor defaultFgColour()
    {
      return self()->mDefaultFgColour;
    }

    /**
      Set Background color
    */
    static
    void setDefaultBgColour( const QColor & v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultBgColour" ) ))
        self()->mDefaultBgColour = v;
    }

    /**
      Get Background color
    */
    static
    QColor defaultBgColour()
    {
      return self()->mDefaultBgColour;
    }

    /**
      Set Message font
    */
    static
    void setMessageFont( const QFont & v )
    {
      if (v != self()->mMessageFont && !self()->isImmutable( QStringLiteral( "MessageFont" ) )) {
        self()->mMessageFont = v;
        self()->mSettingsChanged |= signalMessageFontChanged;
      }
    }

    /**
      Get Message font
    */
    static
    QFont messageFont()
    {
      return self()->mMessageFont;
    }

    /**
      Set Show in system tray
    */
    static
    void setShowInSystemTray( bool v )
    {
      if (v != self()->mShowInSystemTray && !self()->isImmutable( QStringLiteral( "ShowInSystemTray" ) )) {
        self()->mShowInSystemTray = v;
        self()->mSettingsChanged |= signalShowInSystemTrayChanged;
      }
    }

    /**
      Get Show in system tray
    */
    static
    bool showInSystemTray()
    {
      return self()->mShowInSystemTray;
    }

    /**
      Set Auto-hide in system tray if no alarms due within period
    */
    static
    void setBase_AutoHideSystemTray( int v )
    {
      if (v != self()->mBase_AutoHideSystemTray && !self()->isImmutable( QStringLiteral( "Base_AutoHideSystemTray" ) )) {
        self()->mBase_AutoHideSystemTray = v;
        self()->mSettingsChanged |= signalAutoHideSystemTrayChanged;
      }
    }

    /**
      Get Auto-hide in system tray if no alarms due within period
    */
    static
    int base_AutoHideSystemTray()
    {
      return self()->mBase_AutoHideSystemTray;
    }

    /**
      Set Desktops without auto-hide in system tray
    */
    static
    void setNoAutoHideSystemTrayDesktops( const QStringList & v )
    {
      if (!self()->isImmutable( QStringLiteral( "NoAutoHideSystemTrayDesktops" ) ))
        self()->mNoAutoHideSystemTrayDesktops = v;
    }

    /**
      Get Desktops without auto-hide in system tray
    */
    static
    QStringList noAutoHideSystemTrayDesktops()
    {
      return self()->mNoAutoHideSystemTrayDesktops;
    }

    /**
      Set Start at login
    */
    static
    void setAutoStart( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "AutoStart" ) ))
        self()->mAutoStart = v;
    }

    /**
      Get Start at login
    */
    static
    bool autoStart()
    {
      return self()->mAutoStart;
    }

    /**
      Set Suppress autostart at login
    */
    static
    void setBase_NoAutoStart( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "Base_NoAutoStart" ) ))
        self()->mBase_NoAutoStart = v;
    }

    /**
      Get Suppress autostart at login
    */
    static
    bool base_NoAutoStart()
    {
      return self()->mBase_NoAutoStart;
    }

    /**
      Set Default defer time interval
    */
    static
    void setDefaultDeferTime( int v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultDeferTime" ) ))
        self()->mDefaultDeferTime = v;
    }

    /**
      Get Default defer time interval
    */
    static
    int defaultDeferTime()
    {
      return self()->mDefaultDeferTime;
    }

    /**
      Set Prompt for which calendar to store in
    */
    static
    void setAskResource( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "AskResource" ) ))
        self()->mAskResource = v;
    }

    /**
      Get Prompt for which calendar to store in
    */
    static
    bool askResource()
    {
      return self()->mAskResource;
    }

    /**
      Set Message windows have a title bar and take keyboard focus
    */
    static
    void setModalMessages( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "ModalMessages" ) ))
        self()->mModalMessages = v;
    }

    /**
      Get Message windows have a title bar and take keyboard focus
    */
    static
    bool modalMessages()
    {
      return self()->mModalMessages;
    }

    /**
      Set Delay before message window buttons are enabled
    */
    static
    void setMessageButtonDelay( int v )
    {
      if (v < -1)
      {
        qCDebug(KALARM_LOG) << "setMessageButtonDelay: value " << v << " is less than the minimum value of -1";
        v = -1;
      }

      if (v > 10)
      {
        qCDebug(KALARM_LOG) << "setMessageButtonDelay: value " << v << " is greater than the maximum value of 10";
        v = 10;
      }

      if (!self()->isImmutable( QStringLiteral( "MessageButtonDelay" ) ))
        self()->mMessageButtonDelay = v;
    }

    /**
      Get Delay before message window buttons are enabled
    */
    static
    int messageButtonDelay()
    {
      return self()->mMessageButtonDelay;
    }

    /**
      Set Number of alarms to show in system tray tooltip
    */
    static
    void setTooltipAlarmCount( int v )
    {
      if (v != self()->mTooltipAlarmCount && !self()->isImmutable( QStringLiteral( "TooltipAlarmCount" ) )) {
        self()->mTooltipAlarmCount = v;
        self()->mSettingsChanged |= signalTooltipPreferencesChanged;
      }
    }

    /**
      Get Number of alarms to show in system tray tooltip
    */
    static
    int tooltipAlarmCount()
    {
      return self()->mTooltipAlarmCount;
    }

    /**
      Set Show alarm times in system tray tooltip
    */
    static
    void setShowTooltipAlarmTime( bool v )
    {
      if (v != self()->mShowTooltipAlarmTime && !self()->isImmutable( QStringLiteral( "ShowTooltipAlarmTime" ) )) {
        self()->mShowTooltipAlarmTime = v;
        self()->mSettingsChanged |= signalTooltipPreferencesChanged;
      }
    }

    /**
      Get Show alarm times in system tray tooltip
    */
    static
    bool showTooltipAlarmTime()
    {
      return self()->mShowTooltipAlarmTime;
    }

    /**
      Set Show time to alarms in system tray tooltip
    */
    static
    void setShowTooltipTimeToAlarm( bool v )
    {
      if (v != self()->mShowTooltipTimeToAlarm && !self()->isImmutable( QStringLiteral( "ShowTooltipTimeToAlarm" ) )) {
        self()->mShowTooltipTimeToAlarm = v;
        self()->mSettingsChanged |= signalTooltipPreferencesChanged;
      }
    }

    /**
      Get Show time to alarms in system tray tooltip
    */
    static
    bool showTooltipTimeToAlarm()
    {
      return self()->mShowTooltipTimeToAlarm;
    }

    /**
      Set Time-to-alarm prefix in system tray tooltip
    */
    static
    void setTooltipTimeToPrefix( const QString & v )
    {
      if (v != self()->mTooltipTimeToPrefix && !self()->isImmutable( QStringLiteral( "TooltipTimeToPrefix" ) )) {
        self()->mTooltipTimeToPrefix = v;
        self()->mSettingsChanged |= signalTooltipPreferencesChanged;
      }
    }

    /**
      Get Time-to-alarm prefix in system tray tooltip
    */
    static
    QString tooltipTimeToPrefix()
    {
      return self()->mTooltipTimeToPrefix;
    }

    /**
      Set Email client
    */
    static
    void setEmailClient( MailClient v )
    {
      if (!self()->isImmutable( QStringLiteral( "EmailClient" ) ))
        self()->mEmailClient = v;
    }

    /**
      Get Email client
    */
    static
    MailClient emailClient()
    {
      return static_cast<MailClient>(self()->mEmailClient);
    }

    /**
      Set Whether to copy sent emails into KMail's Sent folder.
    */
    static
    void setBase_EmailCopyToKMail( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "Base_EmailCopyToKMail" ) ))
        self()->mBase_EmailCopyToKMail = v;
    }

    /**
      Get Whether to copy sent emails into KMail's Sent folder.
    */
    static
    bool base_EmailCopyToKMail()
    {
      return self()->mBase_EmailCopyToKMail;
    }

    /**
      Set 'From' email address
    */
    static
    void setBase_EmailFrom( const QString & v )
    {
      if (!self()->isImmutable( QStringLiteral( "Base_EmailFrom" ) ))
        self()->mBase_EmailFrom = v;
    }

    /**
      Get 'From' email address
    */
    static
    QString base_EmailFrom()
    {
      return self()->mBase_EmailFrom;
    }

    /**
      Set 'Bcc' email address
    */
    static
    void setBase_EmailBccAddress( const QString & v )
    {
      if (!self()->isImmutable( QStringLiteral( "Base_EmailBccAddress" ) ))
        self()->mBase_EmailBccAddress = v;
    }

    /**
      Get 'Bcc' email address
    */
    static
    QString base_EmailBccAddress()
    {
      return self()->mBase_EmailBccAddress;
    }

    /**
      Set Terminal for command alarms
    */
    static
    void setBase_CmdXTermCommand( const QString & v )
    {
      if (!self()->isImmutable( QStringLiteral( "Base_CmdXTermCommand" ) ))
        self()->mBase_CmdXTermCommand = v;
    }

    /**
      Get Terminal for command alarms
    */
    static
    QString base_CmdXTermCommand()
    {
      return self()->mBase_CmdXTermCommand;
    }

    /**
      Set Start of day for date-only alarms
    */
    static
    void setBase_StartOfDay( const QDateTime & v )
    {
      if (v != self()->mBase_StartOfDay && !self()->isImmutable( QStringLiteral( "Base_StartOfDay" ) )) {
        self()->mBase_StartOfDay = v;
        self()->mSettingsChanged |= signalBase_StartOfDayChanged;
      }
    }

    /**
      Get Start of day for date-only alarms
    */
    static
    QDateTime base_StartOfDay()
    {
      return self()->mBase_StartOfDay;
    }

    /**
      Set Start time of working day
    */
    static
    void setBase_WorkDayStart( const QDateTime & v )
    {
      if (v != self()->mBase_WorkDayStart && !self()->isImmutable( QStringLiteral( "Base_WorkDayStart" ) )) {
        self()->mBase_WorkDayStart = v;
        self()->mSettingsChanged |= signalBase_WorkTimeChanged;
      }
    }

    /**
      Get Start time of working day
    */
    static
    QDateTime base_WorkDayStart()
    {
      return self()->mBase_WorkDayStart;
    }

    /**
      Set End time of working day
    */
    static
    void setBase_WorkDayEnd( const QDateTime & v )
    {
      if (v != self()->mBase_WorkDayEnd && !self()->isImmutable( QStringLiteral( "Base_WorkDayEnd" ) )) {
        self()->mBase_WorkDayEnd = v;
        self()->mSettingsChanged |= signalBase_WorkTimeChanged;
      }
    }

    /**
      Get End time of working day
    */
    static
    QDateTime base_WorkDayEnd()
    {
      return self()->mBase_WorkDayEnd;
    }

    /**
      Set Working days
    */
    static
    void setBase_WorkDays( uint v )
    {
      if (v != self()->mBase_WorkDays && !self()->isImmutable( QStringLiteral( "Base_WorkDays" ) )) {
        self()->mBase_WorkDays = v;
        self()->mSettingsChanged |= signalBase_WorkTimeChanged;
      }
    }

    /**
      Get Working days
    */
    static
    uint base_WorkDays()
    {
      return self()->mBase_WorkDays;
    }

    /**
      Set Disabled alarm color
    */
    static
    void setDisabledColour( const QColor & v )
    {
      if (v != self()->mDisabledColour && !self()->isImmutable( QStringLiteral( "DisabledColour" ) )) {
        self()->mDisabledColour = v;
        self()->mSettingsChanged |= signalDisabledColourChanged;
      }
    }

    /**
      Get Disabled alarm color
    */
    static
    QColor disabledColour()
    {
      return self()->mDisabledColour;
    }

    /**
      Set Archived alarm color
    */
    static
    void setArchivedColour( const QColor & v )
    {
      if (v != self()->mArchivedColour && !self()->isImmutable( QStringLiteral( "ArchivedColour" ) )) {
        self()->mArchivedColour = v;
        self()->mSettingsChanged |= signalArchivedColourChanged;
      }
    }

    /**
      Get Archived alarm color
    */
    static
    QColor archivedColour()
    {
      return self()->mArchivedColour;
    }

    /**
      Set Days to keep expired alarms
    */
    static
    void setArchivedKeepDays( int v )
    {
      if (v != self()->mArchivedKeepDays && !self()->isImmutable( QStringLiteral( "ArchivedKeepDays" ) )) {
        self()->mArchivedKeepDays = v;
        self()->mSettingsChanged |= signalArchivedKeepDaysChanged;
      }
    }

    /**
      Get Days to keep expired alarms
    */
    static
    int archivedKeepDays()
    {
      return self()->mArchivedKeepDays;
    }

    /**
      Set KOrganizer event duration
    */
    static
    void setKOrgEventDuration( int v )
    {
      if (!self()->isImmutable( QStringLiteral( "KOrgEventDuration" ) ))
        self()->mKOrgEventDuration = v;
    }

    /**
      Get KOrganizer event duration
    */
    static
    int kOrgEventDuration()
    {
      return self()->mKOrgEventDuration;
    }

    /**
      Set Number of minutes before alarm to wake from suspend
    */
    static
    void setWakeFromSuspendAdvance( int v )
    {
      if (!self()->isImmutable( QStringLiteral( "WakeFromSuspendAdvance" ) ))
        self()->mWakeFromSuspendAdvance = v;
    }

    /**
      Get Number of minutes before alarm to wake from suspend
    */
    static
    int wakeFromSuspendAdvance()
    {
      return self()->mWakeFromSuspendAdvance;
    }

    /**
      Set Cancel if late (minutes)
    */
    static
    void setDefaultLateCancel( int v )
    {
      if (v < 0)
      {
        qCDebug(KALARM_LOG) << "setDefaultLateCancel: value " << v << " is less than the minimum value of 0";
        v = 0;
      }
      if (!self()->isImmutable( QStringLiteral( "DefaultLateCancel" ) ))
        self()->mDefaultLateCancel = v;
    }

    /**
      Get Cancel if late (minutes)
    */
    static
    int defaultLateCancel()
    {
      return self()->mDefaultLateCancel;
    }

    /**
      Set Auto-close window after late-cancellation time
    */
    static
    void setDefaultAutoClose( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultAutoClose" ) ))
        self()->mDefaultAutoClose = v;
    }

    /**
      Get Auto-close window after late-cancellation time
    */
    static
    bool defaultAutoClose()
    {
      return self()->mDefaultAutoClose;
    }

    /**
      Set Confirm acknowledgement
    */
    static
    void setDefaultConfirmAck( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultConfirmAck" ) ))
        self()->mDefaultConfirmAck = v;
    }

    /**
      Get Confirm acknowledgement
    */
    static
    bool defaultConfirmAck()
    {
      return self()->mDefaultConfirmAck;
    }

    /**
      Set Show in KOrganizer
    */
    static
    void setDefaultCopyToKOrganizer( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultCopyToKOrganizer" ) ))
        self()->mDefaultCopyToKOrganizer = v;
    }

    /**
      Get Show in KOrganizer
    */
    static
    bool defaultCopyToKOrganizer()
    {
      return self()->mDefaultCopyToKOrganizer;
    }

    /**
      Set Sound
    */
    static
    void setDefaultSoundType( SoundType v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultSoundType" ) ))
        self()->mDefaultSoundType = v;
    }

    /**
      Get Sound
    */
    static
    SoundType defaultSoundType()
    {
      return static_cast<SoundType>(self()->mDefaultSoundType);
    }

    /**
      Set Sound file
    */
    static
    void setDefaultSoundFile( const QString & v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultSoundFile" ) ))
        self()->mDefaultSoundFile = v;
    }

    /**
      Get Sound file
    */
    static
    QString defaultSoundFile()
    {
      return self()->mDefaultSoundFile;
    }

    /**
      Set Sound volume
    */
    static
    void setBase_DefaultSoundVolume( int v )
    {
      if (v < -1)
      {
        qCDebug(KALARM_LOG) << "setBase_DefaultSoundVolume: value " << v << " is less than the minimum value of -1";
        v = -1;
      }

      if (v > 100)
      {
        qCDebug(KALARM_LOG) << "setBase_DefaultSoundVolume: value " << v << " is greater than the maximum value of 100";
        v = 100;
      }

      if (!self()->isImmutable( QStringLiteral( "Base_DefaultSoundVolume" ) ))
        self()->mBase_DefaultSoundVolume = v;
    }

    /**
      Get Sound volume
    */
    static
    int base_DefaultSoundVolume()
    {
      return self()->mBase_DefaultSoundVolume;
    }

    /**
      Set Repeat sound file
    */
    static
    void setDefaultSoundRepeat( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultSoundRepeat" ) ))
        self()->mDefaultSoundRepeat = v;
    }

    /**
      Get Repeat sound file
    */
    static
    bool defaultSoundRepeat()
    {
      return self()->mDefaultSoundRepeat;
    }

    /**
      Set Enter script
    */
    static
    void setDefaultCmdScript( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultCmdScript" ) ))
        self()->mDefaultCmdScript = v;
    }

    /**
      Get Enter script
    */
    static
    bool defaultCmdScript()
    {
      return self()->mDefaultCmdScript;
    }

    /**
      Set Command output
    */
    static
    void setDefaultCmdLogType( CmdLogType v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultCmdLogType" ) ))
        self()->mDefaultCmdLogType = v;
    }

    /**
      Get Command output
    */
    static
    CmdLogType defaultCmdLogType()
    {
      return static_cast<CmdLogType>(self()->mDefaultCmdLogType);
    }

    /**
      Set Log file
    */
    static
    void setDefaultCmdLogFile( const QString & v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultCmdLogFile" ) ))
        self()->mDefaultCmdLogFile = v;
    }

    /**
      Get Log file
    */
    static
    QString defaultCmdLogFile()
    {
      return self()->mDefaultCmdLogFile;
    }

    /**
      Set Copy email to self
    */
    static
    void setDefaultEmailBcc( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultEmailBcc" ) ))
        self()->mDefaultEmailBcc = v;
    }

    /**
      Get Copy email to self
    */
    static
    bool defaultEmailBcc()
    {
      return self()->mDefaultEmailBcc;
    }

    /**
      Set Recurrence period
    */
    static
    void setDefaultRecurPeriod( RecurType v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultRecurPeriod" ) ))
        self()->mDefaultRecurPeriod = v;
    }

    /**
      Get Recurrence period
    */
    static
    RecurType defaultRecurPeriod()
    {
      return static_cast<RecurType>(self()->mDefaultRecurPeriod);
    }

    /**
      Set In non-leap years, repeat yearly February 29th alarms on:
    */
    static
    void setDefaultFeb29Type( Feb29Type v )
    {
      if (v != self()->mDefaultFeb29Type && !self()->isImmutable( QStringLiteral( "DefaultFeb29Type" ) )) {
        self()->mDefaultFeb29Type = v;
        self()->mSettingsChanged |= signalFeb29TypeChanged;
      }
    }

    /**
      Get In non-leap years, repeat yearly February 29th alarms on:
    */
    static
    Feb29Type defaultFeb29Type()
    {
      return static_cast<Feb29Type>(self()->mDefaultFeb29Type);
    }

    /**
      Set Reminder units
    */
    static
    void setDefaultReminderUnits( TimePeriod::Units v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultReminderUnits" ) ))
        self()->mDefaultReminderUnits = v;
    }

    /**
      Get Reminder units
    */
    static
    TimePeriod::Units defaultReminderUnits()
    {
      return static_cast<TimePeriod::Units>(self()->mDefaultReminderUnits);
    }

    /**
      Set Pre-alarm action
    */
    static
    void setDefaultPreAction( const QString & v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultPreAction" ) ))
        self()->mDefaultPreAction = v;
    }

    /**
      Get Pre-alarm action
    */
    static
    QString defaultPreAction()
    {
      return self()->mDefaultPreAction;
    }

    /**
      Set Execute pre-alarm action for deferred alarms
    */
    static
    void setDefaultExecPreActionOnDeferral( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultExecPreActionOnDeferral" ) ))
        self()->mDefaultExecPreActionOnDeferral = v;
    }

    /**
      Get Execute pre-alarm action for deferred alarms
    */
    static
    bool defaultExecPreActionOnDeferral()
    {
      return self()->mDefaultExecPreActionOnDeferral;
    }

    /**
      Set Cancel alarm on pre-alarm action error
    */
    static
    void setDefaultCancelOnPreActionError( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultCancelOnPreActionError" ) ))
        self()->mDefaultCancelOnPreActionError = v;
    }

    /**
      Get Cancel alarm on pre-alarm action error
    */
    static
    bool defaultCancelOnPreActionError()
    {
      return self()->mDefaultCancelOnPreActionError;
    }

    /**
      Set Do not notify pre-alarm action errors
    */
    static
    void setDefaultDontShowPreActionError( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultDontShowPreActionError" ) ))
        self()->mDefaultDontShowPreActionError = v;
    }

    /**
      Get Do not notify pre-alarm action errors
    */
    static
    bool defaultDontShowPreActionError()
    {
      return self()->mDefaultDontShowPreActionError;
    }

    /**
      Set Post-alarm action
    */
    static
    void setDefaultPostAction( const QString & v )
    {
      if (!self()->isImmutable( QStringLiteral( "DefaultPostAction" ) ))
        self()->mDefaultPostAction = v;
    }

    /**
      Get Post-alarm action
    */
    static
    QString defaultPostAction()
    {
      return self()->mDefaultPostAction;
    }

    /**
      Set Warn before quitting
    */
    static
    void setBase_QuitWarn( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "Base_QuitWarn" ) ))
        self()->mBase_QuitWarn = v;
    }

    /**
      Get Warn before quitting
    */
    static
    bool base_QuitWarn()
    {
      return self()->mBase_QuitWarn;
    }

    /**
      Set Confirm alarm deletions
    */
    static
    void setBase_ConfirmAlarmDeletion( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "Base_ConfirmAlarmDeletion" ) ))
        self()->mBase_ConfirmAlarmDeletion = v;
    }

    /**
      Get Confirm alarm deletions
    */
    static
    bool base_ConfirmAlarmDeletion()
    {
      return self()->mBase_ConfirmAlarmDeletion;
    }

    /**
      Set Notify when remote emails are queued
    */
    static
    void setBase_EmailQueuedNotify( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "Base_EmailQueuedNotify" ) ))
        self()->mBase_EmailQueuedNotify = v;
    }

    /**
      Get Notify when remote emails are queued
    */
    static
    bool base_EmailQueuedNotify()
    {
      return self()->mBase_EmailQueuedNotify;
    }


    enum {
      signalShowInSystemTrayChanged = 0x1,
      signalAutoHideSystemTrayChanged = 0x2,
      signalBase_TimeZoneChanged = 0x4,
      signalBase_HolidayRegionChanged = 0x8,
      signalBase_StartOfDayChanged = 0x10,
      signalBase_WorkTimeChanged = 0x20,
      signalMessageFontChanged = 0x40,
      signalDisabledColourChanged = 0x80,
      signalArchivedColourChanged = 0x100,
      signalArchivedKeepDaysChanged = 0x200,
      signalFeb29TypeChanged = 0x400,
      signalTooltipPreferencesChanged = 0x800
    };

  Q_SIGNALS:
    void showInSystemTrayChanged(bool ShowInSystemTray);

    void autoHideSystemTrayChanged(int Base_AutoHideSystemTray);

    void base_TimeZoneChanged(const QString & Base_TimeZone);

    void base_HolidayRegionChanged(const QString & Base_HolidayRegion);

    void base_StartOfDayChanged(const QDateTime & Base_StartOfDay);

    void base_WorkTimeChanged(const QDateTime & Base_WorkDayStart, const QDateTime & Base_WorkDayEnd, int Base_WorkDays);

    void messageFontChanged(const QFont & MessageFont);

    void disabledColourChanged(const QColor & DisabledColour);

    void archivedColourChanged(const QColor & ArchivedColour);

    void archivedKeepDaysChanged(int ArchivedKeepDays);

    void feb29TypeChanged(Feb29Type DefaultFeb29Type);

    void tooltipPreferencesChanged();

  private:
    void itemChanged(quint64 flags);

  protected:
    PreferencesBase();
    friend class PreferencesBaseHelper;

    bool usrSave() override;
  protected:

    // General
    QString mVersion;
    int mBackend;
    QString mBase_TimeZone;
    QString mBase_HolidayRegion;
    QColor mDefaultFgColour;
    QColor mDefaultBgColour;
    QFont mMessageFont;
    bool mShowInSystemTray;
    int mBase_AutoHideSystemTray;
    QStringList mNoAutoHideSystemTrayDesktops;
    bool mAutoStart;
    bool mBase_NoAutoStart;
    int mDefaultDeferTime;
    bool mAskResource;
    bool mModalMessages;
    int mMessageButtonDelay;
    int mTooltipAlarmCount;
    bool mShowTooltipAlarmTime;
    bool mShowTooltipTimeToAlarm;
    QString mTooltipTimeToPrefix;
    int mEmailClient;
    bool mBase_EmailCopyToKMail;
    QString mBase_EmailFrom;
    QString mBase_EmailBccAddress;
    QString mBase_CmdXTermCommand;
    QDateTime mBase_StartOfDay;
    QDateTime mBase_WorkDayStart;
    QDateTime mBase_WorkDayEnd;
    uint mBase_WorkDays;
    QColor mDisabledColour;
    QColor mArchivedColour;
    int mArchivedKeepDays;
    int mKOrgEventDuration;
    int mWakeFromSuspendAdvance;

    // Defaults
    int mDefaultLateCancel;
    bool mDefaultAutoClose;
    bool mDefaultConfirmAck;
    bool mDefaultCopyToKOrganizer;
    int mDefaultSoundType;
    QString mDefaultSoundFile;
    int mBase_DefaultSoundVolume;
    bool mDefaultSoundRepeat;
    bool mDefaultCmdScript;
    int mDefaultCmdLogType;
    QString mDefaultCmdLogFile;
    bool mDefaultEmailBcc;
    int mDefaultRecurPeriod;
    int mDefaultFeb29Type;
    int mDefaultReminderUnits;
    QString mDefaultPreAction;
    bool mDefaultExecPreActionOnDeferral;
    bool mDefaultCancelOnPreActionError;
    bool mDefaultDontShowPreActionError;
    QString mDefaultPostAction;

    // Notification Messages
    bool mBase_QuitWarn;
    bool mBase_ConfirmAlarmDeletion;
    bool mBase_EmailQueuedNotify;

  private:
    uint mSettingsChanged;
};

#endif

